// Generated by gtkmmproc -- DO NOT MODIFY!

#include <libsexymm/tree-view.h>
#include <libsexymm/private/tree-view_p.h>

/**
 * @file libsexymm/tree-view.ccg A treeview subclass which can display
                                 tooltips for items in the tree.
 *
 * @Copyright (C) 2006 Christian Hammond.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */

#include <libsexymm/tree-view.h>

namespace Sexy
{

void
TreeView::set_tooltip_label_column(const Gtk::TreeModelColumnBase& column)
{
	set_tooltip_label_column(column.index());
}

} /* namespace Sexy */

// vim: syntax=cpp


namespace
{

GtkWidget* TreeView_signal_get_tooltip_callback(SexyTreeView* self, GtkTreePath* p0,GtkTreeViewColumn* p1,void* data)
{
  using namespace Sexy;
  typedef sigc::slot< Gtk::Widget*,const Gtk::TreeModel::Path&,const Gtk::TreeViewColumn& > SlotType;

  // Do not try to call a signal on a disassociated wrapper.
  if(Glib::ObjectBase::_get_current_wrapper((GObject*) self))
  {
    try
    {
      if(sigc::slot_base *const slot = Glib::SignalProxyNormal::data_to_slot(data))
        return (GtkWidget*)Glib::unwrap((*static_cast<SlotType*>(slot))(Gtk::TreePath(p0, true)
, *Glib::wrap(p1)
));
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
  }

  typedef GtkWidget* RType;
  return RType();
}

GtkWidget* TreeView_signal_get_tooltip_notify_callback(SexyTreeView* self, GtkTreePath* p0,GtkTreeViewColumn* p1, void* data)
{
  using namespace Sexy;
  typedef sigc::slot< void,const Gtk::TreeModel::Path&,const Gtk::TreeViewColumn& > SlotType;

  // Do not try to call a signal on a disassociated wrapper.
  if(Glib::ObjectBase::_get_current_wrapper((GObject*) self))
  {
    try
    {
      if(sigc::slot_base *const slot = Glib::SignalProxyNormal::data_to_slot(data))
        (*static_cast<SlotType*>(slot))(Gtk::TreePath(p0, true)
, *Glib::wrap(p1)
);
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
  }

  typedef GtkWidget* RType;
  return RType();
}

const Glib::SignalProxyInfo TreeView_signal_get_tooltip_info =
{
  "get-tooltip",
  (GCallback) &TreeView_signal_get_tooltip_callback,
  (GCallback) &TreeView_signal_get_tooltip_notify_callback
};

} // anonymous namespace


namespace Glib
{

Sexy::TreeView* wrap(SexyTreeView* object, bool take_copy)
{
  return dynamic_cast<Sexy::TreeView *> (Glib::wrap_auto ((GObject*)(object), take_copy));
}

} /* namespace Glib */

namespace Sexy
{


/* The *_Class implementation: */

const Glib::Class& TreeView_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &TreeView_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(sexy_tree_view_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:
  }

  return *this;
}

void TreeView_Class::class_init_function(void* g_class, void* class_data)
{
  BaseClassType *const klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);

  klass->get_tooltip = &get_tooltip_callback;
}


GtkWidget* TreeView_Class::get_tooltip_callback(SexyTreeView* self, GtkTreePath* p0, GtkTreeViewColumn* p1)
{
  CppObjectType *const obj = dynamic_cast<CppObjectType*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  // Non-gtkmmproc-generated custom classes implicitly call the default
  // Glib::ObjectBase constructor, which sets is_derived_. But gtkmmproc-
  // generated classes can use this optimisation, which avoids the unnecessary
  // parameter conversions if there is no possibility of the virtual function
  // being overridden:
  if(obj && obj->is_derived_())
  {
    try // Trap C++ exceptions which would normally be lost because this is a C callback.
    {
      // Call the virtual member method, which derived classes might override.
      return (GtkWidget*)Glib::unwrap(obj->on_get_tooltip(Gtk::TreePath(p0, true)
, *Glib::wrap(p1)
));
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
  }
  else
  {
    BaseClassType *const base = static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(self)) // Get the parent class of the object class (The original underlying C class).
    );

    // Call the original underlying C function:
    if(base && base->get_tooltip)
      return (*base->get_tooltip)(self, p0, p1);
  }

  typedef GtkWidget* RType;
  return RType();
}


Glib::ObjectBase* TreeView_Class::wrap_new(GObject* o)
{
  return manage(new TreeView((SexyTreeView*)(o)));

}


/* The implementation: */

TreeView::TreeView(const Glib::ConstructParams& construct_params)
:
  Gtk::TreeView(construct_params)
{
  }

TreeView::TreeView(SexyTreeView* castitem)
:
  Gtk::TreeView((GtkTreeView*)(castitem))
{
  }

TreeView::~TreeView()
{
  destroy_();
}

TreeView::CppClassType TreeView::treeview_class_; // initialize static member

GType TreeView::get_type()
{
  return treeview_class_.init().get_type();
}

GType TreeView::get_base_type()
{
  return sexy_tree_view_get_type();
}


TreeView::TreeView()
:
  Glib::ObjectBase(0), //Mark this class as gtkmmproc-generated, rather than a custom class, to allow vfunc optimisations.
  Gtk::TreeView(Glib::ConstructParams(treeview_class_.init()))
{
  }

void TreeView::set_tooltip_label_column(guint column)
{
  sexy_tree_view_set_tooltip_label_column(gobj(), column);
}


Glib::SignalProxy2< Gtk::Widget*,const Gtk::TreeModel::Path&,const Gtk::TreeViewColumn& > TreeView::signal_get_tooltip()
{
  return Glib::SignalProxy2< Gtk::Widget*,const Gtk::TreeModel::Path&,const Gtk::TreeViewColumn& >(this, &TreeView_signal_get_tooltip_info);
}


Gtk::Widget* Sexy::TreeView::on_get_tooltip(const Gtk::TreeModel::Path& path, const Gtk::TreeViewColumn& column)
{
  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)) // Get the parent class of the object class (The original underlying C class).
  );

  if(base && base->get_tooltip)
    return Glib::wrap((*base->get_tooltip)(gobj(),const_cast<GtkTreePath*>((path).gobj()),const_cast<GtkTreeViewColumn*>((column).gobj())));

  typedef Gtk::Widget* RType;
  return RType();
}


} // namespace Sexy


